import os, json, sys
from copy import deepcopy
from constants import *

# phase 1
with open(GRANULAR_TRAIN_P1) as f:
    granular_train_1 = json.load(f)

# phase 2

with open(BASIC_TRAIN_P2) as f:
    basic_train_2 = json.load(f)

with open(GRANULAR_TRAIN_P2) as f:
    granular_train_2 = json.load(f)

for entry_id, entry in basic_train_2['entries'].items():
    if entry_id not in granular_train_2['entries']:
        granular_train_2['entries'][entry_id] = entry

# phase 3

with open(BASIC_TRAIN_P3) as f:
    basic_train_3 = json.load(f)

with open(GRANULAR_TRAIN_P3) as f:
    granular_train_3 = json.load(f)

for entry_id, entry in basic_train_3['entries'].items():
    if entry_id not in granular_train_3['entries']:
        granular_train_3['entries'][entry_id] = entry

if os.path.exists(GRANULAR_HIDDEN_DATA):
    with open(GRANULAR_HIDDEN_DATA) as f:
        granular_hidden_data = json.load(f)
    print('found {} hidden entries'.format(len(granular_hidden_data['entries'])))
    for hidden_entr_id, hidden_entry in granular_hidden_data['entries'].items():
        granular_train_2['entries']['hidden-{}'.format(hidden_entr_id)] = hidden_entry

# combination

granular_train_all = deepcopy(granular_train_1)

for entry_id, entry in granular_train_all['entries'].items():
    entry['phase'] = '1'

print('phase 1 granular entries: {}, phase 2 granular entries: {}, phase 3 granular entries: {}'.format(
    len(granular_train_1['entries']),
    len(granular_train_2['entries']),
    len(granular_train_3['entries'])))

for entry_id, entry in granular_train_2['entries'].items():
    entry['phase'] = '2'
    if entry_id not in granular_train_all['entries']:
        granular_train_all['entries'][entry_id] = entry

for entry_id, entry in granular_train_3['entries'].items():
    entry['phase'] = '3'
    if entry_id not in granular_train_all['entries']:
        granular_train_all['entries'][entry_id] = entry

print('===============================')
print('phase 1+2+3 granular entries: {}'.format(len(granular_train_all['entries'])))

fold = sys.argv[1]

with open('datasets/basic-events/p1p2p3_eng_cv_splits.json') as f:
    fold_info = json.load(f)

test_entry_ids = set(fold_info['cv_{}'.format(fold)])

train_data = deepcopy(granular_train_all)
test_data = deepcopy(granular_train_all)

for entry_id in granular_train_all['entries']:
    if entry_id not in test_entry_ids:
        del test_data['entries'][entry_id]
    else:
        del train_data['entries'][entry_id]

with open(GRANULAR_TRAIN_P1P2P3, 'w') as f:
    json.dump(train_data, f, ensure_ascii=False)

with open(GRANULAR_DEVTEST_REF_P3, 'w') as f:
    json.dump(test_data, f, ensure_ascii=False)

for entry_id, entry in test_data['entries'].items():
    del entry['annotation-sets']

with open(GRANULAR_DEVTEST_EMPTY_P3, 'w') as f:
    json.dump(test_data, f, ensure_ascii=False)

with open(SAMPLE_GRANULAR_CHINESE_P3) as f:
    sample_chinese = json.load(f)

with open(SAMPLE_GRANULAR_KOREAN_P3) as f:
    sample_korean = json.load(f)

with open(SAMPLE_GRANULAR_RUSSIAN_P3) as f:
    sample_russian = json.load(f)

sample_multilingual = deepcopy(sample_chinese)
sample_multilingual['corpus-id'] = 'synthetic_granular_multilingual'

for entry_id, entry in sample_korean['entries'].items():
    if entry_id not in sample_multilingual['entries']:
        sample_multilingual['entries'][entry_id] = entry

for entry_id, entry in sample_russian['entries'].items():
    if entry_id not in sample_multilingual['entries']:
        sample_multilingual['entries'][entry_id] = entry

with open(SAMPLE_GRANULAR_TEST_P3_MULTILINGUAL, 'w') as f:
    json.dump(sample_multilingual, f, ensure_ascii=False)

print('sample chinese granular entries: {}, sample korean granular entries: {}, sample russian granular entries: {}'.format(len(sample_chinese['entries']), len(sample_korean['entries']), len(sample_russian['entries'])))
print('synthetic multilingual granular entries: {}'.format(len(sample_multilingual['entries'])))
