# Copyright (C) 2007 - 2018 The MITRE Corporation. See the toplevel
# file LICENSE.txt for license terms.

import sys

# MAT imports

from . import PluginMgr
from .Command import XMLRPCCommandServer

# This file will ultimately contain the tagger abstractions. Right now
# it's just a dummy class to dominate Carafe.

class Tagger(object):

    def __init__(self, *args, **kw):
        pass

# Global setting for the threaded tagger broker. If this is present,
# the tool will attempt to make a request to the broker directly,
# rather than using XMLRPC.

TAGGER_BROKER = None

# Here's a thread to start up a tagger server accumulator. This
# used to be MATServer, but I'm folding it into a thread here.
# Its children are managed by socket connections, using some ungodly
# complicated connection management code I wrote a long, long
# time ago. Perhaps replace it, someday.

class TaggerBroker(XMLRPCCommandServer):

    def __init__(self, **kw):
        
        pDir = PluginMgr.LoadPlugins()

        processes = []

        # The elements in allServers are a 4-tuple <taskName> <servName> <langAddress> <serverInstance>

        for app in pDir.values():
            processes += app.findServers()

        XMLRPCCommandServer.__init__(self, *processes, **kw)
